"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable:no-bitwise */
// Decode
// Input 16 digit str
// Out unlock str
const GetReverse_1 = require("./GetReverse");
const CharSep_1 = require("./CharSep");
const FullBin_1 = require("./FullBin");
async function decode(input) {
    if (typeof input !== 'string' || input.length !== 16) {
        return Promise.reject('Invalid input');
    }
    const fConv = new Int32Array(1);
    return await CharSep_1.CharSep(input, 0, 8)
        .then((data1) => {
        fConv[0] = parseInt(data1, 16);
        return CharSep_1.CharSep(input, 8, 8);
    })
        .then((data2) => {
        const sConv = new Int32Array(1);
        sConv[0] = parseInt(data2, 16);
        return sConv[0];
    })
        .then((bin) => {
        const unbit = FullBin_1.FullBin((bin >>> 0).toString(2), 32);
        return unbit;
    })
        .then((unbit) => {
        return GetReverse_1.GetReverse(unbit);
    })
        .then((fin) => {
        const test = new Int32Array(1);
        test[0] = parseInt(fin, 2);
        const secondPartRev = test[0];
        return secondPartRev;
    })
        .then((secondPartRev) => {
        const xor = new Int32Array(1);
        xor[0] = fConv[0] ^ secondPartRev;
        return xor[0];
    })
        .then((xor) => {
        const ret = new Int32Array(1);
        ret[0] = xor - 0xE010A11;
        return ret[0];
    })
        .then((ret) => {
        const hex = (ret >>> 0).toString(16);
        const final = FullBin_1.FullBin(hex, 8);
        return Promise.resolve(final);
    })
        .catch((err) => {
        return Promise.reject(err);
    });
}
exports.decode = decode;
